// C Source File
// Created 2/26/2004; 2:39:58 PM
//This program will simulate any site-swap pattern up to seven balls w/ maximum site swap didgit of 7.
#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
//Function prototypes
int x_calc (int,int,int);
int y_calc (int,int,int);






//---------------------------------------------------------------
// input: index, side, SS#
// output: x coordinate
//----------------------------------------------------------------
int x_calc (int xindex,int side, int SSN){
	int x0spot [] = {
		25
	};
	int x1spot [] = {
7,
13,
20,
27,
33,
40,
47,
54,
60,
67
};
	int x2spot [] = {
-1,
-2,
-4,
-5,
-6,
-7,
-9,
-10,
-11,
-12,
-14,
-15,
-16,
-17,
-19,
-20,
-21,
-22,
-24,
-25
	};


	int x3spot [] = {
2,
4,
7,
9,
11,
13,
16,
18,
20,
22,
25,
27,
29,
31,
33,
36,
38,
40,
42,
45,
47,
49,
51,
54,
56,
58,
60,
63,
65,
67
};
int x4spot [] = {
-1,
-1,
-2,
-2,
-3,
-4,
-4,
-5,
-6,
-6,
-7,
-7,
-8,
-9,
-9,
-10,
-11,
-11,
-12,
-12,
-13,
-14,
-14,
-15,
-16,
-16,
-17,
-17,
-18,
-19,
-19,
-20,
-21,
-21,
-22,
-22,
-23,
-24,
-24,
-25
};
int x5spot[] = {
1,
3,
4,
5,
7,
8,
9,
11,
12,
13,
15,
16,
17,
19,
20,
21,
23,
24,
25,
27,
28,
29,
31,
32,
33,
35,
36,
38,
39,
40,
42,
43,
44,
46,
47,
48,
50,
51,
52,
54,
55,
56,
58,
59,
60,
62,
63,
64,
66,
67
};
int x6spot[] ={
0,
-1,
-1,
-2,
-2,
-3,
-3,
-3,
-4,
-4,
-5,
-5,
-5,
-6,
-6,
-7,
-7,
-8,
-8,
-8,
-9,
-9,
-10,
-10,
-10,
-11,
-11,
-12,
-12,
-13,
-13,
-13,
-14,
-14,
-15,
-15,
-15,
-16,
-16,
-17,
-17,
-18,
-18,
-18,
-19,
-19,
-20,
-20,
-20,
-21,
-21,
-22,
-22,
-23,
-23,
-23,
-24,
-24,
-25,
-25
};
int x7spot[] = {
1,
2,
3,
4,
5,
6,
7,
8,
9,
10,
11,
11,
12,
13,
14,
15,
16,
17,
18,
19,
20,
21,
22,
23,
24,
25,
26,
27,
28,
29,
30,
31,
32,
33,
33,
34,
35,
36,
37,
38,
39,
40,
41,
42,
43,
44,
45,
46,
47,
48,
49,
50,
51,
52,
53,
54,
55,
56,
56,
57,
58,
59,
60,
61,
62,
63,
64,
65,
66,
67
};
int carry [] = {
1,
2,
3,
4,
5,
6,
7,
8,
9,
10,
11,
12,
13,
14,
15,
16,
17,
18,
19,
20,
21,
22,
23,
24,
25
};
switch (SSN){
	case 0:
	return x0spot[xindex];
	break;
	
	case 1:
		if (side == 1){
			return (x1spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x1spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;
		
		case 2:
		if (side == 1){
			return (x2spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x2spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;	
		
		
	case 3:	
		if (side == 1){
			return (x3spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x3spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;	
		
		
	case 4:	
		if (side == 1){
			return (x4spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x4spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;	
		
		
	case 5:	
		if (side == 1){
			return (x5spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x5spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;	
		
	case 6:	
		if (side == 1){
			return (x6spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x6spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;	
		
		
	case 7:	
		if (side == 1){
			return (x7spot[xindex]+25);
		}
		if (side == 2){
			return (92 - carry[xindex]);
		}
		if (side == 3){
			return (67- x7spot[xindex]);
		}
		if (side == 4){
			return (carry[xindex]);
		}
		return 40;
	break;
} //for switch
	return 40;
}
 // for function
//------------------------------------------------------------------------------------






//-------------------------------------------------------------------------------------
//  input: index, side, SS#
//  output: y coordinate
//--------------------------------------------
int y_calc (int yindex,int side,int SSN){
	int y0spot [] = {
		0
	};
	int y1spot [] = {
1,
2,
2,
3,
3,
3,
2,
2,
1,
0
	};
	int y2spot [] = {
2,
4,
6,
7,
9,
10,
11,
11,
12,
12,
12,
11,
11,
10,
9,
7,
6,
4,
2,
0
	};
	int y3spot [] = {
3,
7,
9,
12,
15,
17,
19,
21,
22,
23,
24,
25,
26,
26,
26,
26,
26,
25,
24,
23,
22,
21,
19,
17,
15,
12,
9,
7,
3,
0	
};
int y4spot [] = {
5,
9,
13,
17,
20,
24,
27,
30,
33,
35,
37,
39,
41,
42,
44,
45,
46,
46,
47,
47,
47,
46,
46,
45,
44,
42,
41,
39,
37,
35,
33,
30,
27,
24,
20,
17,
13,
9,
5,
0
};
int y5spot [] = {
6,
11,
16,
21,
26,
31,
35,
39,
43,
47,
50,
53,
56,
59,
61,
64,
65,
67,
69,
70,
71,
72,
72,
73,
73,
73,
72,
72,
71,
70,
69,
67,
65,
64,
61,
59,
56,
53,
50,
47,
43,
39,
35,
31,
26,
21,
16,
11,
6,
0
};
int y6spot [] = {
7,
14,
20,
26,
32,
38,
43,
49,
54,
58,
63,
67,
71,
75,
79,
82,
85,
88,
91,
93,
96,
98,
99,
101,
102,
103,
104,
105,
105,
105,
105,
105,
104,
103,
102,
101,
99,
98,
96,
93,
91,
88,
85,
82,
79,
75,
71,
67,
63,
58,
54,
49,
43,
38,
32,
26,
20,
14,
7,
0
};
int y7spot [] = {
8,
16,
23,
31,
38,
45,
51,
58,
64,
70,
76,
81,
86,
92,
96,
101,
105,
109,
113,
117,
120,
123,
126,
129,
131,
134,
136,
137,
139,
140,
141,
142,
143,
143,
143,
143,
143,
142,
141,
140,
139,
137,
136,
134,
131,
129,
126,
123,
120,
117,
113,
109,
105,
101,
96,
92,
86,
81,
76,
70,
64,
58,
51,
45,
38,
31,
23,
16,
8,
0
};
switch (SSN){
	
	case 0:
		if (side == 1){
			return (y0spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y0spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	
	case 1:
		if (side == 1){
			return (y1spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y1spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 2:
		if (side == 1){
			return (y2spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y2spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 3:
		if (side == 1){
			return (y3spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y3spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 4:
		if (side == 1){
			return (y4spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y4spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 5:
		if (side == 1){
			return (y5spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y5spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 6:
		if (side == 1){
			return (y6spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y6spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
	
	
	case 7:
		if (side == 1){
			return (y7spot[yindex]);
		}
		if (side == 2){
			return (0);
		}
		if (side == 3){
			return (y7spot[yindex]);
		}
		if (side == 4){
			return (0);
		}
		return 40;
} // for switch
	return 40;
} // for function
//----------------------------------------------------------------------------------------







void _main(void)
{
//----------------------------------------------------------------------------
//displays coverscreen, gets site swap in 'array[]'and length in 'length'
clrscr();
FontSetSys(F_8x10);
DrawStr(0,0,"                    ",A_REVERSE);
DrawStr(0,10,"     Juggler 89     ",A_REVERSE);
DrawStr(0,20,"                    ",A_REVERSE);
FontSetSys(F_6x8);
DrawStr(0,34,"  By: Steven Wheelwright ",A_NORMAL);
FontSetSys(F_4x6);
DrawStr(0,60,"Advanced Site-Swap simulator:",A_NORMAL);
DrawStr(0,68," Simulates up to 7 balls in any pattern",A_NORMAL);
DrawStr(0,76," Try typing site-swaps like \'7\' or \'5\' or \'5 1\'",A_NORMAL);
FontSetSys(F_6x8);
ngetchx();
clrscr();

printf("Type Site-Swap:\n\n");
int key;
int array[25];
int index2 = 0;
int count = 0;
while ((key = ngetchx()) != KEY_ENTER && count < 20) {
	if (key == '1'){
		printf("1 ");
		array[index2++] = 1; 
		count++;
	}
	if (key == '2'){
		printf("2 ");
		array[index2++] = 2;
		count++;
	}
	if (key == '3'){
		printf("3 ");
		array[index2++] = 3;
		count++;
	}
	if (key == '4'){
		printf("4 ");
		array[index2++] = 4;
		count++;
	}
	if (key == '5'){
		printf("5 ");
		array[index2++] = 5;
		count++;
	}
	if (key == '6'){
		printf("6 ");
		array[index2++] = 6;
		count++;
	}
	if (key == '7'){
		printf("7 ");
		array[index2++] = 7;
		count++;
	}
	if (key == '0'){
		printf("0 ");
		array[index2++] = 0;
		count++;
	}
	if (key == KEY_ESC){
		return;
	}
}
int length = index2;
clrscr();
//determines if site-swap is symmetrical
printf("Is your site-swap\n\n symmetrical?\n\n \'1\' for yes (balls cross)\n\n \'0\' for no (balls stay on\n             one side)");
int sym = 0;
int OK = 0;
while (!OK){
key = ngetchx();
if (key == '1'){
	sym = 1;
	OK = 1;
}
if (key == '0'){
	sym = 0;
	OK =1;
}
if (key == KEY_ESC){
	return;
}
}



//now get total orbit length:
int j = 0;
int sum2= 0;
while (j<length){
	sum2 = sum2 + array[j++];
}
int num_balls = sum2/length;
if (sum2%length != 0){
	printf("Invalid site-swap");
	ngetchx();
	return;
}
int orbit[] = {0,0,0,0,0,0,0,0};
//turn on numbers in orbit[] if found in array
int out = 0;
while (out<length){
	
	for (j=0;j<8;j++){
		if (array[out] == j){
			orbit[j] = 1;
		}//endif
	}//endfor
	out++;
}//endwhile

//find sum of numbers, the number of numbers
int sum = 0;
int num = 0;
int p=0;
while (p<8){
	if (orbit[p] ==1){
		num++;
		sum = sum + p*10;
	}
	p++;
}
int FAC = 1;
if (sym == 1){
	FAC = 2;
}

int time = (sum * FAC + num * FAC * 25);

int delay = time/num_balls;




//------------------------------------------------------------------------------------
//clears screen, displays stats
/*
clrscr();
FontSetSys(F_4x6);
printf("Length of site swap is: %d\n",length); 
printf("# of balls is %d\n",num_balls);
printf("delay is %d\n",delay);
printf("sum of 1 repeat is %d\n",sum);
printf("sum2 is %d\n",sum2);
printf("time is %d\n",time);
printf("fact is %d\n",FAC);
ngetchx();
clrscr();
*/
//assigns starting positions
int spot_in_array = 0;
int ball_SSN[num_balls];
int ball_side[num_balls];
int ball_index[num_balls];
int ball_ready[num_balls];
int ball = 0;
while (ball<num_balls){
	ball_index[ball] = ball * delay;
	ball_ready[ball] = 0;
	ball_side[ball] = 1;
	ball_SSN[ball] = array[spot_in_array];
	ball++;
}
ball = 0;
while (ball<num_balls){
spot_in_array = 0;
do {	
	if (ball_index[ball]> ((ball_SSN[ball])*10)&& (ball_side[ball] ==1 || ball_side[ball] ==3)){
		ball_index[ball] = ball_index[ball] - ball_SSN[ball]*10;
		(ball_side[ball])++;
		}
		
	if (ball_index[ball] > 25 && (ball_side[ball]== 2 || ball_side[ball] == 4)){
		ball_index[ball] = ball_index[ball] -25;
		(ball_side[ball])++;
		if (ball_side[ball]>4){
		ball_side[ball] = 1;
		}
		spot_in_array++;
		if (spot_in_array>length-1){
			spot_in_array = 0;
		}	//endif spot_in_array
		ball_SSN[ball] = array[spot_in_array];
		}	//endif ball_index >25
	} while (((ball_side[ball]==1 || ball_side[ball] ==3) && (ball_index[ball]>ball_SSN[ball]*10)) || ((ball_side[ball] ==2 || ball_side[ball] ==4) && (ball_index[ball]>25))); 
ball++;
}	//end while (not do while)
/*
ball = 0;
while (ball<num_balls){
	printf("ball%d\n",ball);
	printf("side: %d\n",ball_side[ball]);
	printf("SSN: %d\n",ball_SSN[ball]);
	printf("index: %d\n",ball_index[ball]);
	ngetchx();
	clrscr();
	ball++;
}
clrscr();
for (ball = 0;ball<num_balls;ball++){
printf("%d    %d    %d    %d\n",ball,ball_side[ball],ball_SSN[ball],ball_index[ball]);
}
ngetchx();
*/
//------------------------------------------------------------------------------------


static unsigned short int ball1[] = 
	{
	0x1866,
  0x4281,
  0x8142,
  0x6618

  };

static unsigned short int ball2[] = 
	{
	0x187E,
  0x7EFF,
  0xFF7E,
  0x7E18

	};

static unsigned short int ball3[] = 
	{
	0x187E,
  0x7EFF,
  0x8142,
  0x6618

	};

static unsigned short int ball4[] = 
	{
	 0x1866,
  0x4281,
  0xFF7E,
  0x7E18

	};
static unsigned short int ball5[] = 
	{
	0x1876,
  0x72F1,
  0xF172,
  0x7618

	};
static unsigned short int ball6[] = 
	{
	0x186E,
  0x4E8F,
  0x8F4E,
  0x6E18

	};
static unsigned short int ball7[] = 
	{
	  0x1866,
  0x5ABD,
  0xBD5A,
  0x6618
	};
static unsigned short int *balls[] = {ball1,ball2,ball3,ball4,ball5,ball6,ball7};

static unsigned short int logo[] = {
	
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0200,
  0x0400,
  0x0400,
  0x0400,
  0x03F8,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x03E0,
  0x0400,
  0x0400,
  0x0200,
  0x07E0,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x13C0,
  0x1420,
  0x1420,
  0x1240,
  0x0FE0,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x13C0,
  0x1420,
  0x1420,
  0x1240,
  0x0FE0,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0008,
  0x0008,
  0x07F8,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x03C0,
  0x04A0,
  0x04A0,
  0x04A0,
  0x02C0,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x07E0,
  0x0040,
  0x0020,
  0x0020,
  0x0040,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
  0x0000,
};

//------------------------------------------------------------------------------------
// puts on and takes off the balls
//------------------------------------------------------------------------------------
clrscr();
Sprite16(159-16,0,100,logo,LCD_MEM,SPRT_XOR);
spot_in_array = 0;
while (!kbhit()){
	//draw on sprites
	for (ball = 0;ball <num_balls;ball++){
		Sprite8(y_calc(ball_index[ball],ball_side[ball],ball_SSN[ball]),x_calc(ball_index[ball],ball_side[ball],ball_SSN[ball]),8,balls[ball],LCD_MEM,SPRT_XOR);		
	}//endfor
	//wait
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 1);
	while (!OSTimerExpired (USER_TIMER));
	//take off the sprites:
	for (ball = 0;ball <num_balls;ball++){
		Sprite8(y_calc(ball_index[ball],ball_side[ball],ball_SSN[ball]),x_calc(ball_index[ball],ball_side[ball],ball_SSN[ball]),8,balls[ball],LCD_MEM,SPRT_XOR);		
	}//endfor
	
	//increment the coordinates of the balls
	for (ball = 0;ball<num_balls;ball++){
		(ball_index[ball])++;
		if ((ball_side[ball] ==1 || ball_side[ball] == 3) && ball_index[ball] > ball_SSN[ball]*10-1){
			ball_index[ball] = 0;
			if (ball_SSN[ball] == 2 || ball_SSN[ball] ==4 || ball_SSN[ball] ==6){
				(ball_side[ball])--;
				if (ball_side[ball] == 0){
					ball_side[ball] = 4;
				}//0 to four
			}//if 2,4,6
			if (ball_SSN[ball] == 1 || ball_SSN[ball] == 3 || ball_SSN[ball] == 5 || ball_SSN [ball] ==7){
			(ball_side[ball])++;	
			}
			
		}	//end if 1 or 3
		if ((ball_side[ball] ==2 || ball_side[ball] ==4) && ball_index[ball] > 25-1){
			ball_index[ball] = 0;
			(ball_side[ball])++;
			if (ball_side[ball] > 4){	//if side = 5, then back to 1
				ball_side[ball] = 1;
			}
			ball_SSN[ball] = array[spot_in_array++];	//new site swap
			if (spot_in_array>length-1){							//if array siteswap all gone, go back to start
				spot_in_array = 0;
			}
		}// end if 2 or 4
	}//endfor
	
}	//big while
}	//main

